package com.eactive.eai.batch.job.jobItem.shcd;

import java.io.ByteArrayOutputStream;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.batch.common.LogUtil;
import com.eactive.eai.common.exception.ExceptionUtil;

public class RECV_SHCDB_0640 extends DefaultTelegram implements TelegramService
{

    /**
     * 생성자
     */
    public RECV_SHCDB_0640() {
        //화일정보수신통보
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;
        try {
            String fileInfo = new String ((byte[]) al_Field.get(9)); // 화일정보내역
            long fSize = Long.parseLong(fileInfo.substring(8, 20));     //화일 size
            if (getResCode().equalsIgnoreCase(TelegramKeys.RES_CODE_ALREADY_RECEIVED)
                    ||getResCode().equalsIgnoreCase(TelegramKeys.RES_CODE_NOT_REGISTERED)) { //기송신 파일이면
                checkMoreFileinDB();
            } else {
                if (fSize > 0) { //기 송신된 파일이면서 미완료 파일이면
                    setConditionTxt(TelegramKeys.ERROR);
                    throw new Exception("상대 기관에 수신 자료 초기화 요청 바랍니다.");
                } else { //최초 송신이면
                    batchDoc.getBatchMsg().getBody().setBlockNum(0);
                    batchDoc.getBatchMsg().getBody().setSeqNum(0);
                }
            }

        } catch ( Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) { //CMS전문의 헤더는 응답코드까지 임.
                byte[] barr = (byte[])this.al_Field.get(i);
                if ( barr[0] != '\0') {
                    baout.write((byte[])this.al_Field.get(i));
                }
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            LogUtil.setLogFileStart(batchDoc);

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private void checkMoreFileinDB(){
        this.setConditionTxt(TelegramKeys.NOFILE);
        return;

        /*
        String processCode = batchDoc.getBatchMsg().getHeader().getProcessCode();
        String institutionCode = batchDoc.getBatchMsg().getHeader().getInstitutionCode();
        SchedulerMessageVO info;

        try{
            info = SchedulerMessageManager.getInstance().getExecutableJobFromQueue(processCode, institutionCode );
            if ( info == null ) {
                return;
            }
            String strUUID = batchDoc.getBatchMsg().getHeader().getUUID();
            String strSubUUID = batchDoc.getBatchMsg().getBody().getSubUUID();

            //해당 작업을 Job_Queue 테이블에서 Job_Processing 테이블로 이동
            SchedulerMessageManager.getInstance().moveJobQueueToHandleWithNewID(info, strUUID, strSubUUID);

            //BatchMsgDoc 값 설정
            batchDoc.getBatchMsg().getHeader().setScheduleCode(info.getScheduleCode());
            batchDoc.getBatchMsg().getHeader().setScheduleSTime(info.getStartTime());
            batchDoc.getBatchMsg().getHeader().setScheduleETime(info.getEndTime());
            batchDoc.getBatchMsg().getHeader().setFilePath(info.getFilePath());
            batchDoc.getBatchMsg().getHeader().setFileName(info.getFileName());
            batchDoc.getBatchMsg().getHeader().setRenamedFileName(info.getRenamedFileName());
            batchDoc.getBatchMsg().getHeader().setJobCode(info.getJobCode());
            // 0600 전문을 보내어 현재 파일을 마무리 하여야 하므로 여기서 BizCode를 세팅하면 안된다.
            //batchDoc.getEAIBatchMessage().getHeader().setBizCode(info.getBizCode());
            batchDoc.getBatchMsg().getHeader().setFlowCode(info.getFlowRuleCode());
            batchDoc.getBatchMsg().getHeader().setRuleCode(info.getFlowRuleCode());
            batchDoc.getBatchMsg().getHeader().setBlockSize(info.getBlockSize());
            batchDoc.getBatchMsg().getHeader().setSequenceSize(info.getSequenceSize());
            batchDoc.getBatchMsg().getHeader().setPacketSize(info.getPacketSize());
            batchDoc.getBatchMsg().getHeader().setUserID(info.getRemoteUserID());
            batchDoc.getBatchMsg().getHeader().setUserPassword(info.getRemoteUserPW());
            batchDoc.getBatchMsg().getHeader().setFileSize(0);
            batchDoc.getBatchMsg().getBody().setCurFileSize(0);
            this.setConditionTxt(TelegramKeys.EOF);

        } catch ( Exception e){
            logger.error( e.getMessage(), e);
        }
        */
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(4);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(5);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getOpCode();
    }
}